Тёмный

Tiling dominoes | Dynamic programming 

WilliamFiset
Подписаться 179 тыс.
Просмотров 41 тыс.
50% 1

Опубликовано:

 

7 сен 2024

Поделиться:

Ссылка:

Скачать:

Готовим ссылку...

Добавить в:

Мой плейлист
Посмотреть позже
Комментарии : 67   
@WilliamFiset-videos
@WilliamFiset-videos 4 года назад
For those of you looking for a challenge, check out this tiling problem: open.kattis.com/problems/tray The problem is very similar except that it adds two elements of complexity: 1) 1x1 tiles are introduced 2) Some cells are banned
@rohitbohra4248
@rohitbohra4248 4 года назад
Hey for this problem, I am following the similar idea. Here there will be more possible combinations for a particular dp state(a column). I have eliminated the banned cells(set it to INT_MIN) by using a hashmap and checking if a state(out of those 8 as stated in video) is possible or not. I am stuck from this point on. Could you give a hint or something on this problem? Thank you:)
@puneetkumarsingh1484
@puneetkumarsingh1484 4 года назад
The problem just blew my mind! Then solution blew my mind even more! I was like speechless when I saw that each columns tiling pattern could be mapped to 0 to 7 in a binary fashioned way! Thanks a lot. This problem definitely opens mind about how a problem can be approached.
@puneetkumarsingh1484
@puneetkumarsingh1484 4 года назад
@WilliamFiset I think another channel is uploading your videos. Is it your channel or have you provided it with the permission ru-vid.com/video/%D0%B2%D0%B8%D0%B4%D0%B5%D0%BE-1A6OYsKmL1U.html
@Garentei
@Garentei 4 года назад
It always helps to to see some sort of visualization instead of understanding it in the abstract :), great video.
@asma-pe3rx
@asma-pe3rx 4 года назад
Well this was a bitmask dp problem with the best explanation.
@sakshamsethi4123
@sakshamsethi4123 4 года назад
Possibly best tiling video ever
@adityapandey2514
@adityapandey2514 3 года назад
certainly
@adityapandey2514
@adityapandey2514 3 года назад
was stuck for a long time, very very informative,really the best possible explanation, instant share with my friends practicing dp. Thank you keep making these videos.
@egor.okhterov
@egor.okhterov 3 года назад
Variations of this problem: 1. There field is N x M. 2. There are two domino types: 2x1 and 1x1. 3. There is limited number of dominos: A dominos of type 2x1, B dominos of type 1x1. 4. There are dominos of weird shapes like “r” or 2x2 square.
@kirtanitaliya7631
@kirtanitaliya7631 4 года назад
need more videos on DP. Amazing explanations. more, more, more....
@codewithamir21
@codewithamir21 2 года назад
Most intuitive approach for this problem 🔥💖
@CrystalSergeant
@CrystalSergeant 4 года назад
amazing. Please keep doing this. Good DP videos are lacking on youtube.
@nk_goyal
@nk_goyal 3 года назад
Well instead of determining states, a simple solution is to just sum up prev states and then F(n)=3*F(n-2)+2*sum int numTilings(int n) { vector arr(n+1,0); arr[0]=1; int sum=0; for (int i=2;i
@ZeroBit
@ZeroBit 2 года назад
it's not right, ig
@anshumansrivastava8108
@anshumansrivastava8108 4 года назад
what can be more better than this wow...
@timothygao9442
@timothygao9442 4 года назад
Most underrated channel tbh
@tanvirhasan4912
@tanvirhasan4912 4 года назад
Would love more on DP . Great explanation.
@harshsrivastava1819
@harshsrivastava1819 Год назад
love from ghaziabad💕💕💕💕
@jackthehammer2245
@jackthehammer2245 4 года назад
What a cool question and cool DP solution.
@madhukiranattivilli2321
@madhukiranattivilli2321 3 года назад
Wow! Superbly derived solution. Thankyou.
@niyatisrivastava5407
@niyatisrivastava5407 2 года назад
the best possible solution! thanks
@innokentiyromanchenko1450
@innokentiyromanchenko1450 Год назад
this is brilliant
@bonopo
@bonopo 3 года назад
Fun fact: you can do this in log (n) with matrix exponentation (and I think there is a formula to calculate domino tiling as well)
@citizendot1800
@citizendot1800 3 года назад
He did show the formula at the start!
@1vader
@1vader 4 года назад
I solved it quite differently but my submissions always failed because I forgot to output 1 for width 0 >.> I did a recursion on the width: x = 3*f(n-2) for (i = 2; i < width - 2; i += 2) x += 2 * f(i) x += 2 The thing is that the whole rectangle is always filled by two types of blocks: - 2*3 blocks of which there are 3 possible types - 2*(2x) blocks of which there are 2 possible types for every x always arranged like this: 11 55 88 2 33 66 9 2 44 77 9 or the same thing upside down where the middle parts can be repeated to add 2 to the width. This is even fast enough to work without DP. Oh and if width % 2 == 1 i.e. the width is odd I just output 0 immediately.
@CodeCraftWithVinayak
@CodeCraftWithVinayak 4 года назад
I always wait for ur videos WillamFiset
@preethaparasuraman5317
@preethaparasuraman5317 4 года назад
Nice Explaination. Thank you. However i couldn't understand how states 2 and 5 are not possible, but 3 and 7 are possible.
@WilliamFiset-videos
@WilliamFiset-videos 4 года назад
Great question! This might have merited more of an explanation, so let me write it out here. If you have a look at 12:12 when we go from state 2 in column 0 to state 5 in column 1, you will notice that state 2 in column 0 is an impossible state with 1 tile. Similarly, state 5 in column 0 is an impossible state. Both of these impossible states dp[0][2] and dp[0][5] will have an initial value of 0, so dp[1][2] and dp[1][5] will also have a value of 0, and so will dp[i][2] and dp[i][5]. It's safe to remove state 2 and 5 since: 1) no other states depend on states 2 and 5 for their number of tilings 2) states 2 and 5 only depend on each other 3) dp[i][2] and dp[i][5] are always 0
@ragingpahadi
@ragingpahadi 4 года назад
@@WilliamFiset-videos i guess picture is worth thousand words and your explanation was on target. Thanks for making such beautiful video
@chiragyadav4455
@chiragyadav4455 4 года назад
Please upload videos on Convex Hull Algorithms.
@shreshan1
@shreshan1 3 года назад
Wow great explanation thanks
@gautammishra96
@gautammishra96 3 года назад
Awesome explanation!
@DinHamburg
@DinHamburg 3 года назад
I came to find the explanation for sin and cos in the kasteleyn domino-tiling formula - yuk
@factsheet4930
@factsheet4930 3 года назад
I did it much more simply, but thank you for showing me this question nonetheless!
@vishalgaurav4411
@vishalgaurav4411 3 года назад
Can you please give a brief on your approach?
@Drcphd21341
@Drcphd21341 3 года назад
Excellent video, however there is one case which is not expanded on. Theoretically, state 1 can come from state 0, by placing 1 vertical and 1 horizontal domino. How come this is not accounted for?
@Drcphd21341
@Drcphd21341 3 года назад
I guess that the arrangements of Dominos I described above is already counted when state 6 is considered in the creation of state 1. So considering state 0 would be overcounting states. Correct me If I'm wrong
@andrea1955
@andrea1955 4 года назад
Your videos are great! You should consider making one about Push-Relabel. Keep up the good work!
@HiteshSethiya
@HiteshSethiya 4 года назад
You're a great tutor! Let me know if you're starting any mentorship programs.
@jole0
@jole0 4 года назад
This blew my mind! Thank you so much
@kejiadai7716
@kejiadai7716 4 года назад
I have difficulty understand why is only dp[0][7] set to be 1 as the initial value. Could someone explain? Thnaks a lot
@rithwiksrk462
@rithwiksrk462 4 года назад
how many ways is it possible to make an empty grid?
@jole0
@jole0 4 года назад
I also struggled a little with it, but if you apply the algorithm you will see that the only state that is affected by 0 state is 7. The line is ´´dp[i][7] += dp[i-1][0];´´. He is simply extending this logic. Another way to do this is to instead let the code do this for you. Increase the size of the array by one (so it is now n+2), and instead of dp[0][7]=1, you can do dp[0][0]=1, if that makes more sense to you. PS: I got AC with this solution.
@zhaoc033
@zhaoc033 3 года назад
What if there are more than 3 columns? How would the state transition work?
@tuhinmukherjee8141
@tuhinmukherjee8141 3 года назад
Can't dp[i][7] be constructed from dp[i-1][0] in 3 different ways? Clearly, one of them as pointed out in this video is to tile three of them horizontally. The two remaining was are : Tile two of them vertically and another one horizontally underneath them and following symmetry, the opposite. Someone please help me out regarding this!
@MayankKumar-mn3dg
@MayankKumar-mn3dg 2 года назад
That case is already being considered when transitioning from say dp[i-1][6].
@satakshipandey6729
@satakshipandey6729 4 года назад
When we are calculating state 7 from state 0, it should be dp[i][7] += dp[i-2][0] instead of dp[i][7] += dp[i-1][0] or am I. missing something?
@tuhinmukherjee8141
@tuhinmukherjee8141 3 года назад
No, the area difference between dp[i-2][0] and dp[i][7] is 3x3 if you notice carefully. However, one problem lies in the fact that dp[i][7] can be constructed from dp[i-1][0] in 3 different ways. Why do we not account for that?
@thibozaide4429
@thibozaide4429 4 года назад
Great video ! thanks a lot :D
@RedionXhepa
@RedionXhepa 4 года назад
Excelleny video ! Thanks?
@niteshgarg464
@niteshgarg464 3 года назад
Why did the initialisation of dp[0][7] became one. As there is no row behind it it should not be possible ? only dp[0][3] and dp[0][6] should have been initialised to 1 right and all rest 0.
@professorsnapp
@professorsnapp 4 года назад
Thanks my brain said 🤯
@guptagaurav916
@guptagaurav916 2 года назад
Why is dp[0][7] = 1 ?
@ayushprakash3890
@ayushprakash3890 3 года назад
awesome
@himeshgupta6478
@himeshgupta6478 3 года назад
AWESOME!!!!!!!!!!
@syedahmed6568
@syedahmed6568 4 года назад
what softwares do you use to create these videos?
@aminuolawale1843
@aminuolawale1843 3 года назад
Can't state 7 be generated from state 1? Or have I misunderstood something?
@it42titikshagupta9
@it42titikshagupta9 2 года назад
Actually State 7 cannot be generated by state 1 because adding 2*1 tile to state 1 will create dp[i-1][7] and not dp[i][7] and similar is the case of state 4
@CarlosMartinez-jf3rn
@CarlosMartinez-jf3rn 4 года назад
great
@GOODBOY-vt1cf
@GOODBOY-vt1cf 3 года назад
2:00
@lakshmanvengadesan9096
@lakshmanvengadesan9096 3 года назад
Ok, I completely understand this, this is a great video, but how do I think of this in front of the interviewer??? 😖😖😔
@treyquattro
@treyquattro 3 года назад
it turns into a neural net!
@dipenpatel5226
@dipenpatel5226 4 года назад
would you say this could appear in a interview?
@egor.okhterov
@egor.okhterov 3 года назад
Variations of this problem could definitely appear
@GOODBOY-vt1cf
@GOODBOY-vt1cf 3 года назад
2:20
@GOODBOY-vt1cf
@GOODBOY-vt1cf 3 года назад
2:39
Далее
Самое неинтересное видео
00:32
Linkin Park: FROM ZERO (Livestream)
1:03:46
Просмотров 7 млн
A 90-year-old Unsolved Telephone Question
28:45
Просмотров 68 тыс.
Narrow Art Gallery | Dynamic Programming
20:51
Просмотров 9 тыс.
Domino Tiling and Graph Theory
19:02
Просмотров 12 тыс.
The size of your variables matters.
11:03
Просмотров 114 тыс.
Tiling problems [1/2] | Dynamic Programming
16:38
Просмотров 38 тыс.
Самое неинтересное видео
00:32